<?php
/**
 * $Horde$
 *
 * Add Link API for Horde_Links into Nag
 *
 * Copyright 2003, Jeroen Huinink <j.huinink@wanadoo.nl>
 *
 * See the enclosed file COPYING for license information (GPL). If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 * 
 * @author  Jeroen Huinink <j.huinink@wanadoo.nl>
 * @version $Revision$
 * @since   Horde 3.0
 * @package horde.links
 */

/* TODO: This is a quick and dirty implementation. We drag a lot of information
 * in the url. We might want to consider moving this into _SESSION variables.
 * The layout of the page is also rather basic.
 */
@define('NAG_BASE', dirname(__FILE__));
require_once NAG_BASE . '/lib/base.php';
require_once NAG_BASE . '/config/html.php';

/* Allow preferred theme to override settings. */
Horde::getThemeConfig(NAG_BASE);

$link_type = $_SESSION['addlink']['link_type'];
$from_application = $_SESSION['addlink']['from_application'];
$from_parameters = $_SESSION['addlink']['from_parameters'];
$return_url = $_SESSION['addlink']['url'];
$to_application = $_SESSION['addlink']['to_application'];

require NAG_TEMPLATES . '/common-header.inc';


if (!empty($to_application)) {
    require_once HORDE_BASE . '/lib/Links.php';
    $links = &Horde_Links::singleton($registry->getApp());
    $to_parameters = unserialize(Horde::getFormData('to_parameters'));
    $links->addLink($from_application, $from_parameters, $to_application, $to_parameters, $link_type)
?>
<h1>Add Link</h1>
<?php
if ($registry->hasMethod($to_application . '/getLinkDescription')) {
?>
<p>Added a "<?php echo $link_type ?>" link to <?php echo $registry->call($to_application. '/getLinkDescription', $to_parameters); ?>.</p>
<?php } ?>
<p><a href="<?php echo $return_url ?>" class="button"><?php echo _("Continue") ?></a></p>
<?php
} else {

    /* Sort out the sorting values and task filtering. */
    if (($sortby = Horde::getFormData('sortby')) !== null) {
        $prefs->setValue('sortby', $sortby);
    }
    if (($sortdir = Horde::getFormData('sortdir')) !== null) {
        $prefs->setValue('sortdir', $sortdir);
    }
    if (($show_completed = Horde::getFormData('show_completed')) !== null) {
        $prefs->setValue('show_completed', $show_completed);
    }
    
    /* Get the full, sorted task list. */
    $tasks = Nag::listTasks($prefs->getValue('sortby'),
                            $prefs->getValue('sortdir'));
    
    /* Page variables. */
    $i = 0;
    $title = _("Tasks");
    $js_onLoad = null;
    
    $list = Horde::selfURL(false);
    $all_link = Horde::link(Horde::addParameter($list, 'show_completed=1'), _("All tasks"), 'menuitem') . _("All tasks") . '</a>';
    $complete_link = Horde::link(Horde::addParameter($list, 'show_completed=2'), _("Complete tasks"), 'menuitem') . _("Complete tasks") . '</a>';
    $incomplete_link = Horde::link(Horde::addParameter($list, 'show_completed=0'), _("Incomplete tasks"), 'menuitem') . _("Incomplete tasks") . '</a>';
    switch ($prefs->getValue('show_completed')) {
    case 1: // All tasks
        $all_link = _("All tasks");
        break;
    
    case 0: // Incomplete tasks
        $incomplete_link = _("Incomplete tasks");
        break;
    
    case 2: // Complete tasks
        $complete_link = _("Complete tasks");
        break;
    }
    
    require_once HORDE_BASE . '/lib/Menu.php';
    $tasklists = Nag::listTasklists();
    require NAG_TEMPLATES . '/addlink/menu.inc';
    //$notification->notify();
    require NAG_TEMPLATES . '/addlink/javascript.inc';
    require NAG_TEMPLATES . '/addlink/header.inc';
    
    if (count($tasks) > 0) {
        require NAG_TEMPLATES . '/addlink/task_headers.inc';
    
        foreach ($tasks as $task_id => $task) {
            if (!empty($task['completed'])) {
                $style = 'closed';
            } else {
                $style = 'text' . $task['priority'];
            }
            $addurl = Horde::selfUrl(false);
            $addurl = Horde::addParameter($addurl, 'to_application=' . $registry->getParam('provides'));
    
            $share = $GLOBALS['nag_shares']->getShare($task['tasklist_id']);
    
            $owner = $task['tasklist_id'];
            if (!is_a($share, 'PEAR_Error') && $owner != $share->getOwner()) {
                $owner = $share->getShareName();
            }
    
            require NAG_TEMPLATES . '/addlink/task_summaries.inc';
        }
    
        require NAG_TEMPLATES . '/addlink/task_footers.inc';
    } else {
        require NAG_TEMPLATES . '/addlink/empty.inc';
    }
    
    require NAG_TEMPLATES . '/addlink/footer.inc';
}
require NAG_TEMPLATES . '/common-footer.inc';
